% list all of the recordings for each speaker position (take)
default_room_patterns = { ...
'../passive/ford_2221_*.wav'; ...
'../passive/ford_2227_*.wav'; ...
'../passive/ford_2230_*.wav'; ...
'../passive/ford_3317_*.wav'; ...
'../passive/tech_f235_*.wav'; ...
'../passive/tech_f252_*.wav'; ...
'../passive/tech_l158_*.wav'; ...
'../passive/tech_l160_*.wav'; ...
'../passive/tech_l168_*.wav'; ...
'../passive/tech_l170_*.wav'; ...
'../passive/tech_l211_*.wav'; ...
'../passive/tech_l221_*.wav'; ...
'../passive/tech_l251_*.wav'; ...
'../passive/tech_l361_*.wav'; ...
'../passive/tech_lg62_*.wav'; ...
'../passive/tech_lg66_*.wav'; ...
'../passive/tech_lg68_*.wav'; ...
'../passive/tech_lg76_*.wav'; ...
'../passive/tech_lr2_*.wav'; ...
'../passive/tech_lr3_*.wav'; ...
'../passive/tech_lr4_*.wav'; ...
'../passive/tech_lr5_*.wav'; ...
'../passive/tech_m120_*.wav'; ...
'../passive/tech_m128_*.wav'; ...
'../passive/tech_m152_*.wav'; ...
'../passive/tech_m164_*.wav'; ...
'../passive/tech_m166_*.wav'; ...
'../passive/tech_m338_*.wav'; ...
'../passive/tech_m345_*.wav'; ...
'../passive/tech_m349_*.wav'; ...
'../passive/tech_mg51_*.wav'; ...
'../passive/tech_ryan_*.wav'; ...
'../passive/tech_xprs_*.wav'; ...
                };
room_patterns = default_room_patterns;

room_types = {
 'office',
 'lounge',
 'computer lab',
 'classroom',
 'lecture hall'
};
room_type = [
1
2
1
2
4
3
4
4
4
4
5
4
4
5
4
4
4
4
5
5
5
5
4
4
4
4
4
3
5
4
3
5
2
];

HVAC_off_patterns = { ...
'../HVAC_off/tech_f252_*.wav'; ...
'../HVAC_off/tech_l158_*.wav'; ...
'../HVAC_off/tech_l160_*.wav'; ...
'../HVAC_off/tech_l168_*.wav'; ...
'../HVAC_off/tech_l170_*.wav'; ...
'../HVAC_off/tech_l211_*.wav'; ...
'../HVAC_off/tech_l221_*.wav'; ...
'../HVAC_off/tech_l251_*.wav'; ...
'../HVAC_off/tech_lg62_*.wav'; ...
'../HVAC_off/tech_lg66_*.wav'; ...
'../HVAC_off/tech_lg68_*.wav'; ...
'../HVAC_off/tech_lg72_*.wav'; ...
'../HVAC_off/tech_lg76_*.wav'; ...
'../HVAC_off/tech_lr2_*.wav'; ...
'../HVAC_off/tech_lr3_*.wav'; ...
'../HVAC_off/tech_lr4_*.wav'; ...
'../HVAC_off/tech_lr5_*.wav'; ...
'../HVAC_off/tech_m120_*.wav'; ...
'../HVAC_off/tech_m128_*.wav'; ...
'../HVAC_off/tech_m152_*.wav'; ...
'../HVAC_off/tech_m164_*.wav'; ...
'../HVAC_off/tech_m166_*.wav'; ...
'../HVAC_off/tech_xprs_*.wav'; ...
};
% a single day's observations in the same rooms observed with HVAC off
HVAC_on_patterns = { ...
'../passive/tech_f252_101128-*.wav'; ...
'../passive/tech_l158_101128-*.wav'; ...
'../passive/tech_l160_101128-*.wav'; ...
'../passive/tech_l168_101128-*.wav'; ...
'../passive/tech_l170_101128-*.wav'; ...
'../passive/tech_l211_101128-*.wav'; ...
'../passive/tech_l221_101128-*.wav'; ...
'../passive/tech_l251_101128-*.wav'; ...
'../passive/tech_lg62_101128-*.wav'; ...
'../passive/tech_lg66_101128-*.wav'; ...
'../passive/tech_lg68_101128-*.wav'; ...
'../passive/tech_lg72_101128-*.wav'; ...
'../passive/tech_lg76_101128-*.wav'; ...
'../passive/tech_lr2_101128-*.wav'; ...
'../passive/tech_lr3_101128-*.wav'; ...
'../passive/tech_lr4_101128-*.wav'; ...
'../passive/tech_lr5_101128-*.wav'; ...
'../passive/tech_m120_101128-*.wav'; ...
'../passive/tech_m128_101128-*.wav'; ...
'../passive/tech_m152_101128-*.wav'; ...
'../passive/tech_m164_101128-*.wav'; ...
'../passive/tech_m166_101128-*.wav'; ...
'../passive/tech_xprs_101128-*.wav'; ...
};
% all day's observations in the same rooms observed with HVAC off
HVAC_on_patterns_all = { ...
'../passive/tech_f252_*.wav'; ...
'../passive/tech_l158_*.wav'; ...
'../passive/tech_l160_*.wav'; ...
'../passive/tech_l168_*.wav'; ...
'../passive/tech_l170_*.wav'; ...
'../passive/tech_l211_*.wav'; ...
'../passive/tech_l221_*.wav'; ...
'../passive/tech_l251_*.wav'; ...
'../passive/tech_lg62_*.wav'; ...
'../passive/tech_lg66_*.wav'; ...
'../passive/tech_lg68_*.wav'; ...
'../passive/tech_lg72_*.wav'; ...
'../passive/tech_lg76_*.wav'; ...
'../passive/tech_lr2_*.wav'; ...
'../passive/tech_lr3_*.wav'; ...
'../passive/tech_lr4_*.wav'; ...
'../passive/tech_lr5_*.wav'; ...
'../passive/tech_m120_*.wav'; ...
'../passive/tech_m128_*.wav'; ...
'../passive/tech_m152_*.wav'; ...
'../passive/tech_m164_*.wav'; ...
'../passive/tech_m166_*.wav'; ...
'../passive/tech_xprs_*.wav'; ...
};

TAKE_SIZE=4; % we don't use multiple simultaneous recordings in this case
             % setting TAKE_SIZE=1 means that same-visit samples will be 
             % used as training.  If TAKE_SIZE=4, then such samples will
             % be excluded


disp( '* Figure 4: room type histogram' )
h = hist( room_type, 5 );
for i=1:5
    disp( sprintf( '%s\t%d', room_types{i}, h(i) ) );
end
disp(' ');


disp( '* Figure 5: all spectra' );
[spectra, group] = calc_fp_from_files( room_patterns, 'ABS', TAKE_SIZE, ...
                                       'recording_len', 30 );
[score,confusion] = myclassify( spectra, group, TAKE_SIZE );
all_samples = spectra;
plot_samples
disp(' ');

disp( '* Section 5.4: same-visit training' );
score = myclassify( spectra, group, 1 );
disp( sprintf( '\t%.3f', score ) );
disp(' ');


TRIALS=1000;
disp(sprintf('* Figure 6: note that these results are from %d RANDOM trials.',TRIALS) );
[hists, group] = calc_fp_from_files( room_patterns, 'surroundsense', ...
                                     TAKE_SIZE, 'recording_len', 30 );
num_rooms = length( room_patterns ); 
for e=-4:0
    score_abs = 0;
    score_ss = 0;
    for i=1:TRIALS
        score_abs = score_abs + myclassify( spectra, group, TAKE_SIZE, 2^e );
        score_ss = score_ss + myclassify( hists, group, TAKE_SIZE, 2^e );
    end
    disp( sprintf( '%d\t%.3f\t%.3f', floor( num_rooms * 2^e ), ...
                   score_abs/TRIALS, score_ss/TRIALS ) );
end
disp(' ');


disp( '* Figure 7: confusion matrix' );
for i=1:num_rooms
    for j=1:num_rooms
        fprintf('%d ',confusion(i,j));
    end
    fprintf('\n');
end
disp(' ');


disp( '* Figure 8b: distance metric' );
for metric={'euclidean','cityblock', 'cosine', 'correlation', 'seuclidean',...
           'minkowski'}
    [score,confusion] = myclassify( spectra, group, TAKE_SIZE, 1, metric{1} );
    disp( sprintf( '%s\t%.3f', metric{1}, score ) );
end
disp(' ');


disp( '* Figure 8a and Figure 9: frequency bands' );
for band={'all','audible','low','verylow',...
          [0 600],[0 400],[0 300],[0 200],[0 100],'high','ultrasonic'}
    [spectra, group] = calc_fp_from_files( room_patterns, 'ABS', TAKE_SIZE, ...
                                           'recording_len', 30, ...
                                           'band', band{1} );
    [score,confusion] = myclassify( spectra, group, TAKE_SIZE );
    if( isstr(band{1}) )
        disp( sprintf( '%s\t%.3f', band{1}, score ) );
    else
        disp( sprintf( '%d-%d kHz\t%.3f', band{1}(1), band{1}(2), score ) );
    end
    lecture_experiment % figure 9
end
disp(' ');

disp( '* Figure 8c: window type' );
for window_fcn={@rectwin,@hamming,@hann,@blackman}
    [spectra, group] = calc_fp_from_files( room_patterns, 'ABS', TAKE_SIZE, ...
                                             'recording_len', 30, ...
                                             'window_fcn', window_fcn{1} );
    [score,confusion] = myclassify( spectra, group, TAKE_SIZE );
    disp( sprintf( '%s\t%.3f', func2str(window_fcn{1}), score ) );
end
disp(' ');

disp( '* Figure 8d: fingerprint summary type' );
for summary={'mean','min','p05','p10','p25','median','p95','max'}
    [spectra, group] = calc_fp_from_files( room_patterns, 'ABS', TAKE_SIZE, ...
                                             'recording_len', 30, ...
                                             'summary', summary{1} );
    [score,confusion] = myclassify( spectra, group, TAKE_SIZE );
    disp( sprintf( '%s\t%.3f', summary{1}, score ) );
end
disp(' ');

disp( '* Figure 8e: frequency bins' );
for spec_resolution=2.^[1:12]
    [spectra, group] = calc_fp_from_files( room_patterns, 'ABS', TAKE_SIZE, ...
                                             'recording_len', 30, ...
                                         'spec_resolution', spec_resolution );
    [score,confusion] = myclassify( spectra, group, TAKE_SIZE );
    disp( sprintf( '%d\t%.3f', spec_resolution, score ) );
end
disp(' ');

disp( '* Figure 8f: sample time' );
for recording_len=[0.1 0.2 0.5 1 2 4 8 15 30]
    [spectra, group] = calc_fp_from_files( room_patterns, 'ABS', TAKE_SIZE, ...
                                             'recording_len', 30, ...
                                         'recording_len', recording_len ...
                                             );
    [score,confusion] = myclassify( spectra, group, TAKE_SIZE );
    disp( sprintf( '%.1f\t%.3f', recording_len, score ) );
end
disp(' ');


disp( '* Section 5.4: HVAC effects' );
for HVAC_EXPERIMENT=1:4;
    switch( HVAC_EXPERIMENT )
      case 1
        room_patterns = [HVAC_on_patterns_all];
        disp( 'TAKE_SIZE=4, train on, test on' );
        TAKE_SIZE=4;
      case 2
        room_patterns = [HVAC_off_patterns HVAC_on_patterns];
        disp( 'TAKE_SIZE=4, train on/off, test off/on' );
        TAKE_SIZE=4;
      case 3
        room_patterns = [HVAC_off_patterns];
        disp( 'TAKE_SIZE=1, HVAC-OFF only' );
        TAKE_SIZE=1;
      case 4
        room_patterns = [HVAC_on_patterns];
        disp( 'TAKE_SIZE=1, HVAC-ON only' );
        TAKE_SIZE=1;
    end
    [spectra, group] = calc_fp_from_files( room_patterns, 'ABS', TAKE_SIZE, ...
                                           'recording_len', 30 );
    [score,confusion] = myclassify( spectra, group, TAKE_SIZE );
    disp( sprintf( '\t%.3f', score ) );
end
room_patterns = default_room_patterns; % reset
disp(' ');