% run mobisys_study first
width=3;
height=11;
plots=33;

heightfrac = 0.95;
xw = (1/width);
yw = (heightfrac/height);

F = repmat( ([1:299]* 7000/299)', 1,4 );

figure
for( i=0:plots-1 )
    y = mod(i,height);
    x = mod(floor(i/height),width);
    %h=subplot(height,width,i+1);
    pos = [0.025*xw+x/width  (1-heightfrac)+0.05*yw+heightfrac*((height-y-1)/height) 0.95*xw 0.9*yw];
    axes( 'Position', pos );
    plot(F/1000,all_samples(:,8*i+1:8*i+4), 'k-');
    hold on;
    plot(F/1000,5+all_samples(:,8*i+5:8*i+8), 'k-');
    hold off;
    axis([0 7 -3 17] );
    %grid on;
    %set(gca,'Color', [1 1 1]*(0.5+0.5*confusion(i+1,i+1)/8) ); % set BG color
    set(gca,'YTickLabel',{})
    if( y==height-1 )
        set(gca,'XTickLabelMode','auto')
        set(gca,'XTick',[1,2,3,4,5,6,7])
        if( x == 1 )
            xlabel('Frequency (kHz)');
        end
    else
        set(gca,'XTickLabel',{})
    end
    
    [path,name] = fileparts(room_patterns{i+1});

    % HACK name
    name = name(1:end-2);
    name(5) = ' ';
    name(1) = name(1) - 32; % make first char capital
    name = [name(1:4) upper(name(5:end))]; % make room # capital

    text( 0.9, 13, sprintf('Room %d: %s\n                (%s)', i+1, name, ...
                          room_types{room_type(i+1)}), ...
          'FontName', 'Times', 'FontSize', 9);
    text( 4.2, 13, sprintf('Accuracy:%3d%%', ...
                           round(100*confusion(i+1,i+1)/8)), 'FontName', 'Courier',...
          'EdgeColor', 'black', 'FontSize', 9, ...
          'BackgroundColor', [1 1 1]*(0.5+0.5*confusion(i+1,i+1)/8 ) ); % set BG color
end

