function result = smooth_downsample(x,k)
% result = smooth_downsample(x,k)
% 
% Operates column-wise, ie on the first dimension

% this is much faster than the old version, below.
if( k>1 )
    [m,n]=size(x);
    result = reshape( mean(reshape( x, k, n*ceil(m/k) )), ceil(m/k), n );
else 
    result=x;
end

%% old version
%for i=1:size(x,2),
%    result(:,i) = downsample( smooth(x(:,i),k), k );
%end;

%% broken version that can operate on arbitrarily highly dimensional arrays.
%sz = size(x)
%% result will be smaller in the first dimension
%result = zeros( [ floor(sz(1)/k) sz(2:end) ] );
%
%% average out consecutive chunks
%for i=1:k
%size( x( i : k : size(result,1)*k, : ) )
%size( result )
%    result = result + x( i : k : size(result,1)*k, : );
%end
%result = result / k; 


